#include <bits/stdc++.h>

using namespace std;

#define R 3
#define C 3
int min(int x, int y, int z);


int minCost(int a[R][C] ,int n, int m, int b, int c){
a[b][c]==pow(10,9)+1;
        return a[m][n]
        +   min (minCost(a, m - 1, n),
                minCost(a, m, n - 1));
}

int min(int x, int y, int z)
{
    if (x < y)
        return (x < z) ? x : z;
    else
        return (y < z) ? y : z;
}


int main()
{
int n,m;
cin>>n>>m;
int i,j,a[n][m];
for(i=1;i<=n;i++)
for(j=1;j<=n;j++)
cin>>a[i][j];
int Q;
cin>>Q;
int x[Q],y[Q];
for(i=1;i<Q;i++)
cin>>x[i]>>y[i];
for(i=1;i<Q;i++){
minCost(a[m][n],n,m,x[i],y[i]);
}

    return 0;
}